function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useMemo } from "react";
import { Text, View, ScrollView, StyleSheet } from "react-native";
import SyntaxHighlighter from "react-syntax-highlighter";
import { trimNewlines } from "trim-newlines";
import { getRNStylesFromHljsStyle } from "./../utils/styles";
export const CodeHighlighter = _ref => {
  let {
    children,
    containerStyle,
    textStyle,
    hljsStyle,
    scrollViewProps,
    ...rest
  } = _ref;
  const stylesheet = useMemo(() => getRNStylesFromHljsStyle(hljsStyle), [hljsStyle]);
  const getStylesForNode = node => {
    var _node$properties;
    const classes = ((_node$properties = node.properties) === null || _node$properties === void 0 ? void 0 : _node$properties.className) ?? [];
    return classes.map(c => stylesheet[c]).filter(c => !!c);
  };
  const renderNode = function (nodes) {
    let keyPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "row";
    return nodes.reduce((acc, node, index) => {
      const keyPrefixWithIndex = `${keyPrefix}_${index}`;
      if (node.children) {
        var _stylesheet$hljs;
        const styles = StyleSheet.flatten([textStyle, {
          color: (_stylesheet$hljs = stylesheet.hljs) === null || _stylesheet$hljs === void 0 ? void 0 : _stylesheet$hljs.color
        }, getStylesForNode(node)]);
        acc.push( /*#__PURE__*/React.createElement(Text, {
          style: styles,
          key: keyPrefixWithIndex
        }, renderNode(node.children, `${keyPrefixWithIndex}_child`)));
      }
      if (node.value) {
        acc.push(trimNewlines(String(node.value)));
      }
      return acc;
    }, []);
  };
  const renderer = props => {
    const {
      rows
    } = props;
    return /*#__PURE__*/React.createElement(ScrollView, _extends({}, scrollViewProps, {
      horizontal: true,
      contentContainerStyle: [stylesheet.hljs, containerStyle]
    }), /*#__PURE__*/React.createElement(View, null, renderNode(rows)));
  };
  return /*#__PURE__*/React.createElement(SyntaxHighlighter, _extends({}, rest, {
    renderer: renderer,
    CodeTag: View,
    PreTag: View,
    style: {},
    testID: "react-native-code-highlighter"
  }), children);
};
export default CodeHighlighter;
//# sourceMappingURL=CodeHighlighter.js.map